//+------------------------------------------------------------------+
//|                                                  SineSupport.mq4 |
//|                                   Copyright  2008, Craig Dargan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Craig Dargan"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkOrchid
#property indicator_color2 DarkOrange
#property indicator_color3 DarkOrchid
#property indicator_color4 DarkOrange
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
//---- input parameters
extern double    alpha=0.07;
extern double BreakInPips = 1;
extern bool   ShowAlert = true;
extern color  bullishText = DarkOrchid;
extern color  bearishText = DarkOrange;
extern int    nbBars = 2000;

//---- buffers
double resistance[];
double support[];
double sBreak[];
double rBreak[];
int flag;
int draw = 0;
int breakoutFlag = 0;
int pullbackFlag = 0;
datetime prevAlert = NULL;

bool resistanceOccured = false;
bool supportOccured = false;
int direction = 0; // 1 for up, 2 for down
int directionToConfirm = 0;
datetime resistanceTime = NULL;
datetime supportTime = NULL;
double previousResistance = NULL;
double previousSupport = NULL;

datetime lastDrawingTime = NULL;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,1);
   SetIndexArrow(0,119);
   SetIndexBuffer(0,resistance);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,1);
   SetIndexArrow(1,119);
   SetIndexBuffer(1,support);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexStyle(2,DRAW_ARROW,0,2);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,sBreak);
   SetIndexLabel(2,"sBreak");
   SetIndexEmptyValue(2,0.0);
   //SetIndexEmptyValue(1,0.0);
   SetIndexStyle(3,DRAW_ARROW,0,2);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,rBreak);
   SetIndexLabel(3,"rBreak");
   SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   deleteAll();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void deleteAll() {
   ObjectDelete("sBreak");
   ObjectDelete("rBreak");
   
   string objectsToDelete[];
   int nbObjectsToDelete = 0;
   
   int objTotal = ObjectsTotal();
   string name;
   
   ArrayResize(objectsToDelete, objTotal);
   
   for (int i = 0; i < objTotal; i++) {
      name = ObjectName(i);
      
      if (StringSubstr(name, 0, 2) == "PB" || StringSubstr(name, 0, 3) == "END") {
         objectsToDelete[nbObjectsToDelete] = name;
         nbObjectsToDelete++;  
      }   
   }
   
   for (int j = 0; j < nbObjectsToDelete; j++) {
      ObjectDelete(objectsToDelete[j]);
   }
   
   for (j = 0; j < nbObjectsToDelete; j++) {
      ObjectDelete(objectsToDelete[j]);
   }
}

int start()
{
   BreakInPips = BreakInPips * Point;
   
   /*draw = 0;
   breakoutFlag = 0;
   pullbackFlag = 0;
   prevAlert = NULL;

   direction = 0; // 1 for up, 2 for down*/
   
   if (lastDrawingTime != NULL && lastDrawingTime == Time[1])
      return(0);
   
   lastDrawingTime = Time[1];
   deleteAll();
   
   for (int i=nbBars;i>0;i--)
   {
      double sine=iCustom(Symbol(),0,"Sinewave2",alpha,0,i);
      double lead=iCustom(Symbol(),0,"Sinewave2",alpha,1,i);
      double sinelast=iCustom(Symbol(),0,"Sinewave2",alpha,0,i+1);
      double leadlast=iCustom(Symbol(),0,"Sinewave2",alpha,1,i+1);
      
      
      
      if (leadlast>=sinelast && lead<sine)    // trend down
      {
         direction = 2;
         
         //resistance[i]=iHigh(Symbol(),0,i);
         //support[i]=NULL;
         //draw = 1;                
      }
      else if (leadlast<=sinelast && lead>sine)  //trend up
      {
         direction = 1;
         //resistance[i]=NULL;
         //support[i]=iLow(Symbol(),0,i);
         //draw = -1;
         //supportTime = Time[i];   
      }
      
      
      if (direction == 2 && Low[i] < Low[i+1] && resistance[i+1] == NULL) {
         resistance[i]=iHigh(Symbol(),0,i);
         previousSupport = support[i+1];
         support[i]=NULL;
         draw = 1;
         
         
         if (breakoutFlag == -1 && previousSupport != NULL && resistance[i] < previousSupport && pullbackFlag != 1) { //--Pull Back
            pullbackFlag = -1;
            breakoutFlag = 0;
            DrawText(Time[i+3], resistance[i], "PB", bullishText);     
         }
         
         if (pullbackFlag == 1) {
            if (previousSupport != NULL && resistance[i] > previousSupport) {
               DrawText(Time[i+3], resistance[i], "END", bullishText);
            }
            breakoutFlag = 0;
            pullbackFlag = 0;
         }    
         
         resistanceOccured = false;
         //supportOccured = false;
      }
      else if (direction == 1 && High[i] > High[i+1] && support[i+1] == NULL) {
         previousResistance = resistance[i+1];
         resistance[i]=NULL;
         support[i]=iLow(Symbol(),0,i);
         draw = -1;
         
         
         if (breakoutFlag == 1 && previousResistance != NULL && support[i] > previousResistance && pullbackFlag != -1) { //--Pull Back
            pullbackFlag = 1;
            breakoutFlag = 0;
            DrawText(Time[i+3], support[i], "PB", bearishText);     
         }
         
         if (pullbackFlag == -1) {
            if (previousResistance != NULL && support[i] < previousResistance) {
               DrawText(Time[i+3], support[i], "END", bearishText);
            }
            breakoutFlag = 0;
            pullbackFlag = 0;
         }       
         
         //resistanceOccured = false;
         supportOccured = false;
      }
      else
      {
         resistance[i]=resistance[i+1];   
         support[i]=support[i+1];
      }
   
     
     if (resistance[i] != NULL && Close[i] > resistance[i] && draw == 1) {
         if (i > 0) {
            rBreak[i] = High[i];
            sBreak[i] = NULL;
            draw = 0;
            breakoutFlag = 1;
         
         if (ShowAlert && ((i <= 1 && prevAlert == NULL) || (prevAlert < Time[i]))) {
            Alert(Symbol() + "(" + Period() + ") breakout upwards at " + TimeToStr(Time[i]) + "!");
            prevAlert = Time[i];
         }
         }
     }
     
     if (support[i] != NULL && Close[i] < support[i] && draw == -1) {
         if (i > 0) {
            rBreak[i] = NULL;
            sBreak[i] = Low[i];
            draw = 0;
            breakoutFlag = -1;
         
         if (ShowAlert && ((i <= 1 && prevAlert == NULL) || (prevAlert < Time[i]))) {
            Alert(Symbol() + "(" + Period() + ") breakout downwards at " + TimeToStr(Time[i]) + "!");
            prevAlert = Time[i];
         }
         }
     }
  }

//----
   return(0);
}
//+------------------------------------------------------------------+

void DrawText(datetime x1, double y1, string name, color lineColor) {
   string DrawText1 = name + DoubleToStr(x1, 0);
   ObjectCreate(DrawText1, OBJ_TEXT, 0, x1, y1, 0, 0);
   ObjectSetText(DrawText1, name, 8, "Comic Sans MS", lineColor);
}